Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.xpath
Class XPathFunctionLibrary

    java.lang.Object
      net.sf.saxon.xpath.XPathFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary

    public class XPathFunctionLibrary

extends Object
implements FunctionLibrary

The XPathFunctionLibrary is a FunctionLibrary that supports binding of XPath function calls to instances of the JAXP XPathFunction interface returned by an XPathFunctionResolver.

See Also:
  Serialized Form

Constructor Summary
`XPathFunctionLibrary()` Construct a XPathFunctionLibrary

Method Summary
`Expression` | `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env, Container container)` Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`SequenceType[]` | `getFunctionSignature(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available; if so, return its signature.
`XPathFunctionResolver` | `getXPathFunctionResolver()` Get the resolver
`void` | `setXPathFunctionResolver(XPathFunctionResolver resolver)` Set the resolver

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathFunctionLibrary

    public XPathFunctionLibrary()

  Construct a XPathFunctionLibrary

Method Detail

### setXPathFunctionResolver

    public void setXPathFunctionResolver(XPathFunctionResolver resolver)

  Set the resolver

  Parameters:
    `resolver` - The XPathFunctionResolver wrapped by this FunctionLibrary

### getXPathFunctionResolver

    public XPathFunctionResolver getXPathFunctionResolver()

  Get the resolver

  Returns:
    the XPathFunctionResolver wrapped by this FunctionLibrary

### getFunctionSignature

    public SequenceType[] getFunctionSignature(StructuredQName functionName,
                                               int arity)

  Test whether a function with a given name and arity is available; if so, return its signature. This supports the function-available() function in XSLT; it is also used to support higher-order functions introduced in XQuery 1.1. For this function library the method is never used and therefore returns null.

  This method may be called either at compile time or at run time. If the function library is to be used only in an XQuery or free-standing XPath environment, this method may throw an UnsupportedOperationException.

  Specified by:
    `getFunctionSignature` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the qualified name of the function being called
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some function of this name available for calling.
  Returns:
    if a function of this name and arity is available for calling, then the type signature of the function, as an array of sequence types in which the zeroth entry represents the return type; or a zero-length array if the function exists but the signature is not known; or null if the function does not exist

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env,
                           Container container)
                    throws XPathException

  Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` -
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
    `env` -
    `container` -
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name, arity, or signature.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.